#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
    "flipped": 0,
    "segs": 2,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():
    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    flipped = int(cmdlinearg("flipped"))
    segs = int(cmdlinearg("segs"))
    

    starts = random.sample(range(0, n-segs+1), segs)
    starts.sort()
    ans = ['1'] * n
    for i in range(0, segs):
        ans[starts[i] + i] = '2'
    for i in range(1, n):
        if ans[i] == '1' and ans[i-1] == '2' and (i == n-1 or ans[i+1] != '2'):
            if random.randint(0,n // (2*segs)) != 0:
                ans[i] = '2'
    if not flipped:
        print(1, n)
        print("".join(ans))
    else:
        print(n, 1)
        for c in ans:
            print(c)



if __name__ == "__main__":
    main()